
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

#ifndef	FILL_VALUE
#define FILL_VALUE	20.0/27.0
#endif

static Cell	***cell;

static void	Menger_Sponge(int x,int y,int z,int size)
{
	int	i,j,k;

	if ((size/=3)==0)
	    cell[z][y][x]=(Cell)((double)(FILL_VALUE)*255.0+0.5);
	else
	    for (i=0; i<3; i++)
	    for (j=0; j<3; j++)
	    for (k=0; k<3; k++)
		if ((i==1)+(j==1)+(k==1)<2)
		    Menger_Sponge(x+k*size,y+j*size,z+i*size,size);
}

#define LEN	2048

int	main(int argc,char **argv)
{
	int	i,size,z,y,x,len;
	char	form[LEN],path[LEN];

	if (argc!=3) {
	    (void)fputs("usage : m_s iterations directory\n",stderr); exit(1);
	}
	if ((i=atoi(argv[1]))<0) {
	    (void)fputs("bad number of iteration.\n",stderr); exit(1);
	}
	size=1; while (--i>=0) size*=3;

	if ((cell=(Cell ***)malloc(sizeof(Cell **)*size))==NULL ||
	    (*cell=(Cell **)malloc(sizeof(Cell *)*size*size))==NULL ||
	    (**cell=(Cell *)malloc(sizeof(Cell)*size*size*size))==NULL) {
	    (void)fputs("memory allocation error.\n",stderr); exit(1);
	}
	for (z=0; z<size; z++) {
	    if (z>0) cell[z]=cell[z-1]+size;

	    for (y=0; y<size; y++) {
		if (y>0 || z>0) cell[z][y]=cell[z][y-1]+size;

		for (x=0; x<size; x++) cell[z][y][x]=0;
	    }
	}
	Menger_Sponge(0,0,0,size);

	len=1; for (i=10; i<size; i*=10) ++len;
	(void)sprintf(form,"%s/%%0%dd.tif",argv[2],len);

	for (z=0; z<size; z++) {
	    (void)sprintf(path,form,z);
	    StoreImageFile(path,size,size,8,cell[z],NULL);
	}
	free(**cell); free(*cell); free(cell); return 0;
}
